Unit AEG1Z_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AA01Z_p, AA02Z_p, AA03Z_p, UTAE10_p;

procedure AEG1Z(N :Integer; var AR :Array of Extended;
                var AI :Array of Extended; var EVR :Array of Extended;
                var EVI :Array of Extended; var VR :Array of Extended;
                var VI :Array of Extended; var RAB :Array of Extended;
                var IERR :Integer);

implementation

procedure AEG1Z(N :Integer; var AR :Array of Extended;
                var AI :Array of Extended; var EVR :Array of Extended;
                var EVI :Array of Extended; var VR :Array of Extended;
                var VI :Array of Extended; var RAB :Array of Extended;
                var IERR :Integer);
var
IR1,IR2,A,B,C,D,E,F,G,H,P,Q,R,S,T,U,V,W,X,Y,Z,BA,BB,BC,BD,NA,NB,NC,NR,
   NT,NP :Integer;
I,J,K,L,M,O,BE,BF,BG,BH,BI,BJ,BK,BL,BM,BN,BO,BQ,BR :Extended;
const
SYS051 :Extended = 1.1107652e-16;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50,_51,_52,_53,
_54,_55,_56,_57;
begin
IR1 := 1;
IR2 := N;
F := IR2-1;
H := IR1+1;
if ( F < H ) 
 then goto _12;
for C:=H to F do
 begin
  NC := N+C;
  K := 0.0;
  RAB[C-1] := 0.0;
  RAB[NC-1] := 0.0;
  O := 0.0;
  for A:=C to IR2 do
   begin
_1:
    O := O+Abs(AR[(A-1)+(C-2)*N])+Abs(AI[(A-1)+(C-2)*N]);
   end;
  if ( O = 0.0 ) 
   then goto _11;
  G := C+IR2;
  for D:=C to IR2 do
   begin
    A := G-D;
    NA := N+A;
    RAB[A-1] := AR[(A-1)+(C-2)*N]/O;
    RAB[NA-1] := AI[(A-1)+(C-2)*N]/O;
    K := K+RAB[A-1]*RAB[A-1]+RAB[NA-1]*RAB[NA-1];
_2:
   end;
  J := Sqrt(K);
  I := AA01Z(RAB[C-1],RAB[NC-1]);
  if ( I = 0.0 ) 
   then goto _3;
  K := K+I*J;
  J := J/I;
  RAB[C-1] := (1.0+J)*RAB[C-1];
  RAB[NC-1] := (1.0+J)*RAB[NC-1];
  goto _4;
_3:
  RAB[C-1] := J;
  AR[(C-1)+(C-2)*N] := O;
_4:
  for B:=C to N do
   begin
    M := 0.0;
    L := 0.0;
    for D:=C to IR2 do
     begin
      A := G-D;
      NA := N+A;
      M := M+RAB[A-1]*AR[(A-1)+(B-1)*N]+RAB[NA-1]*AI[(A-1)+(B-1)*N];
      L := L+RAB[A-1]*AI[(A-1)+(B-1)*N]-RAB[NA-1]*AR[(A-1)+(B-1)*N];
_5:
     end;
    M := M/K;
    L := L/K;
    for A:=C to IR2 do
     begin
      NA := N+A;
      AR[(A-1)+(B-1)*N] := AR[(A-1)+(B-1)*N]-M*RAB[A-1]+L*RAB[NA-1];
      AI[(A-1)+(B-1)*N] := AI[(A-1)+(B-1)*N]-M*RAB[NA-1]-L*RAB[A-1];
_6:
     end;
_7:
   end;
  for A:=1 to IR2 do
   begin
    M := 0.0;
    L := 0.0;
    for E:=C to IR2 do
     begin
      B := G-E;
      NB := N+B;
      L := L+RAB[B-1]*AI[(A-1)+(B-1)*N]+RAB[NB-1]*AR[(A-1)+(B-1)*N];
      M := M+RAB[B-1]*AR[(A-1)+(B-1)*N]-RAB[NB-1]*AI[(A-1)+(B-1)*N];
_8:
     end;
    M := M/K;
    L := L/K;
    for B:=C to IR2 do
     begin
      NB := N+B;
      AI[(A-1)+(B-1)*N] := AI[(A-1)+(B-1)*N]+M*RAB[NB-1]-L*RAB[B-1];
      AR[(A-1)+(B-1)*N] := AR[(A-1)+(B-1)*N]-M*RAB[B-1]-L*RAB[NB-1];
_9:
     end;
_10:
   end;
  RAB[C-1] := O*RAB[C-1];
  RAB[NC-1] := O*RAB[NC-1];
  AR[(C-1)+(C-2)*N] := -J*AR[(C-1)+(C-2)*N];
  AI[(C-1)+(C-2)*N] := -J*AI[(C-1)+(C-2)*N];
_11:
 end;
_12:
IERR := 0;
for P:=1 to N do
 begin
  for Q:=1 to N do
   begin
    VR[(P-1)+(Q-1)*N] := 0.0;
    VI[(P-1)+(Q-1)*N] := 0.0;
    if ( P = Q ) 
     then VR[(P-1)+(Q-1)*N] := 1.0;
_13:
   end;
 end;
BD := IR2-IR1-1;
if ( BD ) < 0
 then goto _25
 else if ( BD ) > 0
       then goto _14
       else goto _20;
_14:
for V:=1 to BD do
 begin
  P := IR2-V;
  NP := N+P;
  if ( RAB[P-1] = 0.0 ) and ( RAB[NP-1] = 0.0 ) 
   then goto _19;
  if ( AR[(P-1)+(P-2)*N] = 0.0 ) and ( AI[(P-1)+(P-2)*N] = 0.0 ) 
   then goto _19;
  BO := AR[(P-1)+(P-2)*N]*RAB[P-1]+AI[(P-1)+(P-2)*N]*RAB[NP-1];
  Z := P+1;
  for R:=Z to IR2 do
   begin
    NR := N+R;
    RAB[R-1] := AR[(R-1)+(P-2)*N];
    RAB[NR-1] := AI[(R-1)+(P-2)*N];
_15:
   end;
  for Q:=P to IR2 do
   begin
    BF := 0.0;
    BE := 0.0;
    for R:=P to IR2 do
     begin
      NR := N+R;
      BF := BF+RAB[R-1]*VR[(R-1)+(Q-1)*N]+RAB[NR-1]*VI[(R-1)+(Q-1)*N];
      BE := BE+RAB[R-1]*VI[(R-1)+(Q-1)*N]-RAB[NR-1]*VR[(R-1)+(Q-1)*N];
_16:
     end;
    BF := BF/BO;
    BE := BE/BO;
    for R:=P to IR2 do
     begin
      NR := N+R;
      VR[(R-1)+(Q-1)*N] := VR[(R-1)+(Q-1)*N]+BF*RAB[R-1]-BE*RAB[NR-1];
      VI[(R-1)+(Q-1)*N] := VI[(R-1)+(Q-1)*N]+BF*RAB[NR-1]+BE*RAB[R-1];
_17:
     end;
_18:
   end;
_19:
 end;
_20:
S := IR1+1;
for P:=S to IR2 do
 begin
  X := Min0(P+1,IR2);
  if ( AI[(P-1)+(P-2)*N] = 0.0 ) 
   then goto _24;
  BO := AA01Z(AR[(P-1)+(P-2)*N],AI[(P-1)+(P-2)*N]);
  BL := AR[(P-1)+(P-2)*N]/BO;
  BK := AI[(P-1)+(P-2)*N]/BO;
  AR[(P-1)+(P-2)*N] := BO;
  AI[(P-1)+(P-2)*N] := 0.0;
  for Q:=P to N do
   begin
    BE := BL*AI[(P-1)+(Q-1)*N]-BK*AR[(P-1)+(Q-1)*N];
    AR[(P-1)+(Q-1)*N] := BL*AR[(P-1)+(Q-1)*N]+BK*AI[(P-1)+(Q-1)*N];
    AI[(P-1)+(Q-1)*N] := BE;
_21:
   end;
  for Q:=1 to X do
   begin
    BE := BL*AI[(Q-1)+(P-1)*N]+BK*AR[(Q-1)+(P-1)*N];
    AR[(Q-1)+(P-1)*N] := BL*AR[(Q-1)+(P-1)*N]-BK*AI[(Q-1)+(P-1)*N];
    AI[(Q-1)+(P-1)*N] := BE;
_22:
   end;
  for Q:=IR1 to IR2 do
   begin
    BE := BL*VI[(Q-1)+(P-1)*N]+BK*VR[(Q-1)+(P-1)*N];
    VR[(Q-1)+(P-1)*N] := BL*VR[(Q-1)+(P-1)*N]-BK*VI[(Q-1)+(P-1)*N];
    VI[(Q-1)+(P-1)*N] := BE;
_23:
   end;
_24:
 end;
_25:
for P:=1 to N do
 begin
  if ( P >= IR1 ) and ( P <= IR2 ) 
   then goto _26;
  EVR[P-1] := AR[(P-1)+(P-1)*N];
  EVI[P-1] := AI[(P-1)+(P-1)*N];
_26:
 end;
U := IR2;
BH := 0.0;
BG := 0.0;
_27:
if ( U < IR1 ) 
 then goto _46;
BA := 0;
BC := U-1;
_28:
for X:=IR1 to U do
 begin
  S := U+IR1-X;
  if ( S = IR1 ) 
   then goto _30;
  if ( Abs(AR[(S-1)+(S-2)*N]) <= SYS051*(Abs(AR[(S-2)+(S-2)*N])+
       Abs(AI[(S-2)+(S-2)*N])+
       Abs(AR[(S-1)+(S-1)*N])+Abs(AI[(S-1)+(S-1)*N])) ) 
   then goto _30;
_29:
 end;
_30:
if ( S = U ) 
 then goto _45;
if ( BA = 30 ) 
 then goto _56;
if ( BA = 10 ) or ( BA = 20 ) 
 then goto _32;
BF := AR[(U-1)+(U-1)*N];
BE := AI[(U-1)+(U-1)*N];
BJ := AR[(BC-1)+(U-1)*N]*AR[(U-1)+(BC-1)*N];
BI := AI[(BC-1)+(U-1)*N]*AR[(U-1)+(BC-1)*N];
if ( BJ = 0.0 ) and ( BI = 0.0 ) 
 then goto _33;
BL := (AR[(BC-1)+(BC-1)*N]-BF)/2.0;
BK := (AI[(BC-1)+(BC-1)*N]-BE)/2.0;
AA03Z(IntPower(BL,2)-IntPower(BK,2)+BJ,2.0e0*BL*BK+BI,BN,BM);
if ( BL*BN+BK*BM >= 0.0 ) 
 then goto _31;
BN := -BN;
BM := -BM;
_31:
AA02Z(BJ,BI,BL+BN,BK+BM,BQ,BR);
BF := BF-BQ;
BE := BE-BR;
goto _33;
_32:
BF := Abs(AR[(U-1)+(BC-1)*N])+Abs(AR[(BC-1)+(U-3)*N]);
BE := 0.0;
_33:
for P:=IR1 to U do
 begin
  AR[(P-1)+(P-1)*N] := AR[(P-1)+(P-1)*N]-BF;
  AI[(P-1)+(P-1)*N] := AI[(P-1)+(P-1)*N]-BE;
_34:
 end;
BH := BH+BF;
BG := BG+BE;
BA := BA+1;
BB := S+1;
for P:=BB to U do
 begin
  BF := AR[(P-1)+(P-2)*N];
  AR[(P-1)+(P-2)*N] := 0.0;
  BO := Sqrt(IntPower(AR[(P-2)+(P-2)*N],2)+IntPower(AI[(P-2)+(P-2)*N],2)+BF*BF);
  BJ := AR[(P-2)+(P-2)*N]/BO;
  EVR[P-2] := BJ;
  BI := AI[(P-2)+(P-2)*N]/BO;
  EVI[P-2] := BI;
  AR[(P-2)+(P-2)*N] := BO;
  AI[(P-2)+(P-2)*N] := 0.0;
  AI[(P-1)+(P-2)*N] := BF/BO;
  for Q:=P to N do
   begin
    BL := AR[(P-2)+(Q-1)*N];
    BK := AI[(P-2)+(Q-1)*N];
    BN := AR[(P-1)+(Q-1)*N];
    BM := AI[(P-1)+(Q-1)*N];
    AR[(P-2)+(Q-1)*N] := BJ*BL+BI*BK+AI[(P-1)+(P-2)*N]*BN;
    AI[(P-2)+(Q-1)*N] := BJ*BK-BI*BL+AI[(P-1)+(P-2)*N]*BM;
    AR[(P-1)+(Q-1)*N] := BJ*BN-BI*BM-AI[(P-1)+(P-2)*N]*BL;
    AI[(P-1)+(Q-1)*N] := BJ*BM+BI*BN-AI[(P-1)+(P-2)*N]*BK;
_35:
   end;
_36:
 end;
BE := AI[(U-1)+(U-1)*N];
if ( BE = 0.0 ) 
 then goto _38;
BO := AA01Z(AR[(U-1)+(U-1)*N],BE);
BF := AR[(U-1)+(U-1)*N]/BO;
BE := BE/BO;
AR[(U-1)+(U-1)*N] := BO;
AI[(U-1)+(U-1)*N] := 0.0;
if ( U = N ) 
 then goto _38;
Z := U+1;
for Q:=Z to N do
 begin
  BL := AR[(U-1)+(Q-1)*N];
  BK := AI[(U-1)+(Q-1)*N];
  AR[(U-1)+(Q-1)*N] := BF*BL+BE*BK;
  AI[(U-1)+(Q-1)*N] := BF*BK-BE*BL;
_37:
 end;
_38:
for Q:=BB to U do
 begin
  BJ := EVR[Q-2];
  BI := EVI[Q-2];
  for P:=1 to Q do
   begin
    BL := AR[(P-1)+(Q-2)*N];
    BK := 0.0;
    BN := AR[(P-1)+(Q-1)*N];
    BM := AI[(P-1)+(Q-1)*N];
    if ( P = Q ) 
     then goto _39;
    BK := AI[(P-1)+(Q-2)*N];
    AI[(P-1)+(Q-2)*N] := BJ*BK+BI*BL+AI[(Q-1)+(Q-2)*N]*BM;
_39:
    AR[(P-1)+(Q-2)*N] := BJ*BL-BI*BK+AI[(Q-1)+(Q-2)*N]*BN;
    AR[(P-1)+(Q-1)*N] := BJ*BN+BI*BM-AI[(Q-1)+(Q-2)*N]*BL;
    AI[(P-1)+(Q-1)*N] := BJ*BM-BI*BN-AI[(Q-1)+(Q-2)*N]*BK;
_40:
   end;
  for P:=IR1 to IR2 do
   begin
    BL := VR[(P-1)+(Q-2)*N];
    BK := VI[(P-1)+(Q-2)*N];
    BN := VR[(P-1)+(Q-1)*N];
    BM := VI[(P-1)+(Q-1)*N];
    VR[(P-1)+(Q-2)*N] := BJ*BL-BI*BK+AI[(Q-1)+(Q-2)*N]*BN;
    VI[(P-1)+(Q-2)*N] := BJ*BK+BI*BL+AI[(Q-1)+(Q-2)*N]*BM;
    VR[(P-1)+(Q-1)*N] := BJ*BN+BI*BM-AI[(Q-1)+(Q-2)*N]*BL;
    VI[(P-1)+(Q-1)*N] := BJ*BM-BI*BN-AI[(Q-1)+(Q-2)*N]*BK;
_41:
   end;
_42:
 end;
if ( BE = 0.0 ) 
 then goto _28;
for P:=1 to U do
 begin
  BL := AR[(P-1)+(U-1)*N];
  BK := AI[(P-1)+(U-1)*N];
  AR[(P-1)+(U-1)*N] := BF*BL-BE*BK;
  AI[(P-1)+(U-1)*N] := BF*BK+BE*BL;
_43:
 end;
for P:=IR1 to IR2 do
 begin
  BL := VR[(P-1)+(U-1)*N];
  BK := VI[(P-1)+(U-1)*N];
  VR[(P-1)+(U-1)*N] := BF*BL-BE*BK;
  VI[(P-1)+(U-1)*N] := BF*BK+BE*BL;
_44:
 end;
goto _28;
_45:
AR[(U-1)+(U-1)*N] := AR[(U-1)+(U-1)*N]+BH;
EVR[U-1] := AR[(U-1)+(U-1)*N];
AI[(U-1)+(U-1)*N] := AI[(U-1)+(U-1)*N]+BG;
EVI[U-1] := AI[(U-1)+(U-1)*N];
U := BC;
goto _27;
_46:
BO := 0.0;
for P:=1 to N do
 begin
  for Q:=P to N do
   begin
    BO := BO+Abs(AR[(P-1)+(Q-1)*N])+Abs(AI[(P-1)+(Q-1)*N]);
_47:
   end;
 end;
if ( N = 1 ) or ( BO = 0.0 ) 
 then goto _57;
for Y:=2 to N do
 begin
  U := N+2-Y;
  BJ := EVR[U-1];
  BI := EVI[U-1];
  BC := U-1;
  for V:=1 to BC do
   begin
    P := U-V;
    BN := AR[(P-1)+(U-1)*N];
    BM := AI[(P-1)+(U-1)*N];
    if ( P = BC ) 
     then goto _49;
    Z := P+1;
    for Q:=Z to BC do
     begin
      BN := BN+AR[(P-1)+(Q-1)*N]*AR[(Q-1)+(U-1)*N]-AI[(P-1)+(Q-1)*N]*AI[(Q-1)+(U-1)*N];
      BM := BM+AR[(P-1)+(Q-1)*N]*AI[(Q-1)+(U-1)*N]+AI[(P-1)+(Q-1)*N]*AR[(Q-1)+(U-1)*N];
_48:
     end;
_49:
    BL := BJ-EVR[P-1];
    BK := BI-EVI[P-1];
    if ( BL = 0.0 ) and ( BK = 0.0 )
     then BL := SYS051*BO;
    AA02Z(BN,BM,BL,BK,AR[(P-1)+(U-1)*N],AI[(P-1)+(U-1)*N]);
_50:
   end;
_51:
 end;
BC := N-1;
for P:=1 to BC do
 begin
  if ( P >= IR1 ) and ( P <= IR2 ) 
   then goto _53;
  Z := P+1;
  for Q:=Z to N do
   begin
    VR[(P-1)+(Q-1)*N] := AR[(P-1)+(Q-1)*N];
    VI[(P-1)+(Q-1)*N] := AI[(P-1)+(Q-1)*N];
_52:
   end;
_53:
 end;
for W:=IR1 to BC do
 begin
  Q := N+IR1-W;
  T := Min0(Q-1,IR2);
  for P:=IR1 to IR2 do
   begin
    BN := VR[(P-1)+(Q-1)*N];
    BM := VI[(P-1)+(Q-1)*N];
    for R:=IR1 to T do
     begin
      BN := BN+VR[(P-1)+(R-1)*N]*AR[(R-1)+(Q-1)*N]-VI[(P-1)+(R-1)*N]*AI[(R-1)+(Q-1)*N];
      BM := BM+VR[(P-1)+(R-1)*N]*AI[(R-1)+(Q-1)*N]+VI[(P-1)+(R-1)*N]*AR[(R-1)+(Q-1)*N];
_54:
     end;
    VR[(P-1)+(Q-1)*N] := BN;
    VI[(P-1)+(Q-1)*N] := BM;
_55:
   end;
 end;
goto _57;
_56:
IERR := U;
_57:
if ( IERR <> 0 ) 
 then UTAE10(IERR,N,10);
end;

end.
